Subject: Validationresovler regex fails for more than one validator with options
Description

A validation consisting of 2 validations having options makes the regex fail.
E.g.: @validate $whatever stringLength(minimum="5"), bla(abc="123")
Results in (not the options part):

array(1) {
  [0]=>
  array(5) {
    [0]=>
    string(41) "stringLength(minimum="5"), bla(abc="123")" 
    ["validatorName"]=>.
    string(12) "stringLength" 
    [1]=>
    string(12) "stringLength" 
    ["validatorOptions"]=>
    string(27) "minimum="5"), bla(abc="123"" 
    [2]=>
    string(27) "minimum="5"), bla(abc="123"" 
  }
}

Changing
const PATTERN_MATCH_VALIDATORS = '/(?:^|,\s*)(?P<validatorName>[a-z0-9\\\\]+)\s*(?:\((?P<validatorOptions>.+)\))?/i';

To
const PATTERN_MATCH_VALIDATORS = '/(?:^|,\s*)(?P<validatorName>[a-z0-9\\\\]+)\s*(?:\((?P<validatorOptions>[^)]+)\))?/i';
Seems to solve this issue. Could anyone please confirm. Thought this might fail as well for something like "bla(myoptions="asfasF)").

see http://forge.typo3.org/issues/show/5046 as well.

Related issues:
related to TYPO3.Flow - Bug # 5185: ValidatorResolver fails to parse @validat... Resolved 2009-10-30

Associated revisions
Revision 753b0287 - 2009-10-30 16:48 - Karsten Dambekalns

[+BUGFIX] FLOW3 (Validation): Multiple validators with option can now be specified in @validate, fixes #5047.

History
http://forge.typo3.org/issues/show/5046


#1 - 2009-10-26 13:16 - Karsten Dambekalns
- Category set to Validation
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns
- Target version set to 1.0 alpha 6

#2 - 2009-10-26 13:51 - Karsten Dambekalns

Your suggested fix indeed breaks an existing test (using ")" inside an option value). I'll look into that for alpha6.

#3 - 2009-10-27 18:08 - Sebastian Kurfuerst

Karsten Dambekalns wrote:

Your suggested fix indeed breaks an existing test (using ")" inside an option value). I'll look into that for alpha6.

I've been implementing a lot of this for Fluid: 

(?:                               # either...
    "(?:\\\"|[^"])*"              # a double-quoted string
    |\'(?:\\\\\'|[^\'])*\'        # or a single quoted string
)\s*                              #

So, this says:
    -  Inside double quotes, allow any combination of:
        -  escaped double quotes
        -  any other characters except double quote

And for the single-quote case it's the same, just some more escaping because the regex is enclosed in single quotes.

Hope this helps!
Greets, Sebastian

#4 - 2009-10-30 17:00 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r3386.
